Dungeon Game

来源:互联网 发布:威斯盾断桥铝 知乎 编辑:程序博客网 时间:2024/05/22 15:44

这道题试了好久,始终在动态规划时无法保证局部最优解是全局最优解的一部分,很恼人。后来参考了论坛大神的代码,unlock了solution,总算是搞明白了究竟是怎么回事儿。

贴上Leetcode的解析供大家学习:


At first glance, this problem bears a large resemblance to the "Maximum/Minimum Path Sum" problem. However, a path with maximum overall health gain does not guarantee the minimum initial health, since it is essential in the current problem that the health never drops to zero or below. For instance, consider the following two paths:0 -> -300 -> 310 -> 0 and 0 -> -1 -> 2 -> 0. The net health gain along these paths are -300 + 310 = 10 and -1 + 2 = 1, respectively. The first path has the greater net gain, but it requires the initial health to be at least 301 in order to balance out the -300 loss in the second room, whereas the second path only requires an initial health of 2.

Fortunately, this problem can be solved through a table-filling Dynamic Programming technique, similar to other "grid walking" problems:

  • To begin with, we should maintain a 2D array D of the same size as the dungeon, where D[i][j] represents the minimum health that guarantees the survival of the knight for the rest of his quest BEFORE entering room(i, j). Obviously D[0][0] is the final answer we are after. Hence, for this problem, we need to fill the tablefrom the bottom right corner to left top.

  • Then, let us decide what the health should be at least when leaving room (i, j). There are only two paths to choose from at this point: (i+1, j) and (i, j+1). Of course we will choose the room that has the smaller D value, or in other words, the knight can finish the rest of his journey with a smaller initial health. Therefore we have:

      min_HP_on_exit = min(D[i+1][j], D[i][j+1])
  • Now D[i][j] can be computed from dungeon[i][j] and min_HP_on_exit based on one of the following situations:

    1. If dungeon[i][j] == 0, then nothing happens in this room; the knight can leave the room with the same health he enters the room with, i.e. D[i][j] = min_HP_on_exit.
    2. If dungeon[i][j] < 0, then the knight must have a health greater than min_HP_on_exit before entering (i, j) in order to compensate for the health lost in this room. The minimum amount of compensation is "-dungeon[i][j]", so we have D[i][j] = min_HP_on_exit - dungeon[i][j].
    3. If dungeon[i][j] > 0, then the knight could enter (i, j) with a health as little as min_HP_on_exit - dungeon[i][j], since he could gain "dungeon[i][j]" health in this room. However, the value of min_HP_on_exit - dungeon[i][j] might drop to 0 or below in this situation. When this happens, we must clip the value to 1 in order to make sure D[i][j] stays positive: D[i][j] = max(min_HP_on_exit - dungeon[i][j], 1).

    Notice that the equation for dungeon[i][j] > 0 actually covers the other two situations. We can thus describe all three situations with one common equation, i.e.:

    D[i][j] = max(min_HP_on_exit - dungeon[i][j], 1)

    for any value of dungeon[i][j].

  • Take D[0][0] and we are good to go. Also, like many other "table-filling" problems, the 2D array D can be replaced with a 1D "rolling" array here.


class Solution {public:    int calculateMinimumHP(vector<vector<int> > &dungeon) {        int M = dungeon.size();        int N = dungeon[0].size();        // hp[i][j] represents the min hp needed at position (i, j)        // Add dummy row and column at bottom and right side        vector<vector<int> > hp(M + 1, vector<int>(N + 1, INT_MAX));        hp[M][N - 1] = 1;        hp[M - 1][N] = 1;        for (int i = M - 1; i >= 0; i--) {            for (int j = N - 1; j >= 0; j--) {                int need = min(hp[i + 1][j], hp[i][j + 1]) - dungeon[i][j];                hp[i][j] = need <= 0 ? 1 : need;            }        }        return hp[0][0];    }};


0 0
原创粉丝点击